config/routes.rb
Rails.application.routes.draw do
  root to: "home#index"
  resources :artefacts
  resources :tasks
  resources :bpmn_processes
  get :uploads, :controller => :uploads, :action => :index
  get :report, to: 'report#index', as: :report
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/task.rb
class Task < ApplicationRecord
  belongs_to :bpmn_process
  has_many :artefacts, :dependent => :destroy

  #Looks for activities that are "sourceRef" in sequences where this task is found. In other words, activities that are executed before this one
  def incoming
    find_sequences = SequenceFlow.where(targetRef: self[:original_id])
    if find_sequences
      sequences = find_sequences.map{ |sequence| sequence[:sourceRef]}
      return Task.where(original_id: sequences)
    end
  end

#Looks for activities that are "targetRef" in sequences where this task is found. In other words, activities that are executed after this one
  def outgoing
    find_sequences = SequenceFlow.where(sourceRef: self[:original_id])
    if find_sequences
      sequences = find_sequences.map{ |sequence| sequence[:targetRef]}
      return Task.where(original_id: sequences)
    end
  end
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  before_action :set_task, only: [:show, :edit, :update, :destroy]

  # GET /tasks
  # GET /tasks.json
  def index
    @tasks = Task.all
  end

  # GET /tasks/1
  # GET /tasks/1.json
  def show
  end

  # GET /tasks/new
  def new
    @task = Task.new
  end

  # GET /tasks/1/edit
  def edit
  end

  # POST /tasks
  # POST /tasks.json
  def create
    @task = Task.new(task_params)

    respond_to do |format|
      if @task.save
        format.html { redirect_to @task, notice: 'Task was successfully created.' }
        format.json { render :show, status: :created, location: @task }
      else
        format.html { render :new }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tasks/1
  # PATCH/PUT /tasks/1.json
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to @task, notice: 'Task was successfully updated.' }
        format.json { render :show, status: :ok, location: @task }
      else
        format.html { render :edit }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1
  # DELETE /tasks/1.json
  def destroy
    @task.destroy
    respond_to do |format|
      format.html { redirect_to tasks_url, notice: 'Task was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_task
      @task = Task.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def task_params
      params.require(:task).permit(:name, :bpmn_process_id)
    end
end

app/helpers/tasks_helper.rb
module TasksHelper
end

app/views/tasks/_form.html.erb
<%= form_for(task) do |f| %>
  <% if task.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(task.errors.count, "error") %> prohibited this task from being saved:</h2>

      <ul>
      <% task.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %>
    <%= f.text_field :name %>
  </div>

  <div class="field">
    <%= f.label :bpmn_process_id %>
    <%= f.number_field :bpmn_process_id %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/tasks/edit.html.erb
<h1>Editing Task</h1>

<%= render 'form', task: @task %>

<%= link_to 'Show', @task %> |
<%= link_to 'Back', tasks_path %>

app/views/tasks/index.html.erb
<h1>Tasks</h1>

<p id="notice"><%= notice %></p>

<%= link_to 'New Task', new_task_path %>

<table class="table table-bordered">

  <thead>
    <tr>
      <th>Name</th>
      <th>Original Id</th>
      <th>
        Process Name
      </th>
      <th colspan="2"></th>
    </tr>
  </thead>

  <tbody>
    <% @tasks.each do |task| %>
      <tr>
        <td><%= link_to task.name, task_path(task) %></td>
        <td><%= task.original_id %></td>
        <td><%= task.bpmn_process.name %></td>
        <td><%= link_to 'Destroy', task, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/tasks/new.html.erb
<h1>New Task</h1>

<%= render 'form', task: @task %>

<%= link_to 'Back', tasks_path %>

app/views/tasks/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @task.name %>
</p>

<p>
  <strong>Bpmn process:</strong>
  <%= @task.bpmn_process.name %>
</p>

<p>
  <strong>Incoming activites: </strong>
  <% @task.incoming.each do |task| %>
    <%= "#{task.name}; " %>
  <% end %>
</p>

<p>
  <strong>Outgoing activites: </strong>
  <% @task.outgoing .each do |task| %>
    <%= "#{task.name}; " %>
  <% end %>
</p>

<%= link_to 'Edit', edit_task_path(@task) %> |
<%= link_to 'Back', tasks_path %>